.8086
	include	casm.inc

;****************************************************************************
CODE	segment	byte public
	assume cs:CODE

	hp_data_offs	dw	(?)
	hp_data_seg	dw	(?)		;hp descriptor table
	hp_charptrs	dw	256	dup	(?)

	hp_width	dw	(?)
	hp_height	dw	(?)
	hp_char_del	dw	(?)
	hp_orient	db	(?)
	hp_fixpro	db	(?)
	hp_cell_hi	dw	(?)
	hp_cell_wid	dw	(?)
	hp_base_line	dw	(?)

	hpx		dw	?
	hpy		dw	?
	hpx1		dw	?
	hpy1		dw	?
	rect_addr	dw	2	dup	(?)

        hp_str_len      db      (?)

;*****************************************************************************
;	It uses HP Laser Font.A pointer table has to be prepared
;	by  SetcharBase.
;	6		10		12
;	string	ptr	x		y





        start_c_proc    hp_string_out
                lds     si,dword ptr [bp+10]
                les     di,dword ptr [bp+10]

                inc     si

                cld

                xor     cx,cx
                mov     cl,byte ptr es:[di]
                mov     hp_str_len,cl
                rep     movsb

                xor     ax,ax
                mov     byte ptr es:[di],al

                push    [bp+6]
                push    [bp+8]
                push    [bp+12]
                push    [bp+10]
                call    far ptr _hp_string_out

                lds     si,dword ptr [bp+10]
                les     di,dword ptr [bp+10]

                xor     ax,ax
                mov     al,hp_str_len
                add     si,ax
                add     di,ax
                dec     si

                std

                xor     cx,cx
                mov     cl,hp_str_len

                rep     movsb

                mov     al,hp_str_len
                mov     byte ptr es:[di],al

        end_c_proc      hp_string_out,8



	start_c_proc	_hp_string_out
	cli
	mov	cx,[bp+10]
	mov	dx,[bp+12]

	les	di,dword ptr [bp+6]		;loads string pointer
	mov	ds,hp_data_seg


	hp_char_code:				;get character code
	mov	bl,es:[di]
	inc	di

	or	bl,bl				;is this terminate char
	je	hp_string_exit			;exit procedure
	cmp	bl,0ah
	je	hp_string_exit

		xor	bh,bh			;get pointer to descriptor
		shl	bx,1
		mov	si,hp_charptrs[bx]	;es:di points to descriptor
		or	si,si			;skip if char not defined
		$IF	E
			push	hp_cell_wid
			pop	hp_char_del
			jmp	hp_next_char
		$ENDIF


		push	cx			;save character position
		push	dx			;
		push	es
		push	di
		;------- ds:si points to descriptor
		;------- store descriptors values
		add	si,6			;advance to info

		lodsw   			;hp left offset
		xchg	al,ah
		add	cx,ax			;update x

		lodsw				;hp top offset
		xchg	al,ah
		sub	dx,ax			;update y

		lodsw				;hp char width
		xchg	ah,al
		mov	hp_width,ax

		lodsw           		;hp char height
		xchg	ah,al
		mov	hp_height,ax

		lodsw
		xchg	ah,al			;hp char delta x
		shr	ax,1
		shr	ax,1
		mov	hp_char_del,ax

		;-------ds:si now points to character data




		push	ds
		push	si
		push	cx
		push	dx
		push	hp_width
		push	hp_height

		call    far  ptr  put_icon
		;add	sp,12




		pop	di
		pop	es
		pop     dx			;restore character position
		pop	cx
		;-----------------------------------------
	hp_next_char:

	cmp	hp_orient,0
	$IF	E
		add	cx,hp_char_del
	$ELSE
		add	dx,hp_char_del
	$ENDIF

	jmp	hp_char_code			;one more char
	hp_string_exit:
	sti
	end_c_proc	_hp_string_out,8













        start_c_proc    clear_hp_string
                lds     si,dword ptr [bp+10]
                les     di,dword ptr [bp+10]

                inc     si

                cld

                xor     cx,cx
                mov     cl,byte ptr es:[di]
                mov     hp_str_len,cl
                rep     movsb

                xor     ax,ax
                mov     byte ptr es:[di],al

                push    [bp+6]
                push    [bp+8]
                push    [bp+12]
                push    [bp+10]
                call    far ptr _clear_hp_string

                lds     si,dword ptr [bp+10]
                les     di,dword ptr [bp+10]

                xor     ax,ax
                mov     al,hp_str_len
                add     si,ax
                add     di,ax
                dec     si

                std

                xor     cx,cx
                mov     cl,hp_str_len

                rep     movsb

                mov     al,hp_str_len
                mov     byte ptr es:[di],al

        end_c_proc      clear_hp_string,8




;*****************************************************************************
;	This  procedure clears hp string with current draw_color
;	6	string		10-12  scrpos

	start_c_proc	_clear_hp_string
	cli

	mov	cx,[bp+10]
	mov	dx,[bp+12]

	les	di,dword ptr [bp+6]		;loads string pointer
	mov	ds,hp_data_seg


	hp_char_code_cl:			;get character code
	mov	bl,es:[di]
	inc	di


	cmp	bl,0ah
	je	clear_hp_string_exit
	or	bl,bl				;is this terminate char
	je	clear_hp_string_exit		;exit procedure

		xor	bh,bh			;get pointer to descriptor
		shl	bx,1
		mov	si,hp_charptrs[bx]	;es:di points to descriptor
		or	si,si			;skip if char not defined
		$IF	E
			push	hp_cell_wid
			pop	hp_char_del
			jmp	hp_next_char_cl
		$ENDIF


		push	cx			;save character position
		push	dx			;
		push	es
		push	di
		;------- ds:si points to descriptor
		;------- store descriptors values
		add	si,6			;advance to info

		lodsw   			;hp left offset
		xchg	al,ah
		add	cx,ax			;update x

		lodsw				;hp top offset
		xchg	al,ah
		sub	dx,ax			;update y

		lodsw				;hp char width
		xchg	ah,al
		mov	hp_width,ax

		lodsw           		;hp char height
		xchg	ah,al
		mov	hp_height,ax

		lodsw
		xchg	ah,al			;hp char delta x
		shr	ax,1
		shr	ax,1
		mov	hp_char_del,ax

		mov	ax,cx			;get right x
		add	ax,hp_width
		dec	ax

		mov	bx,dx			;get bottom y
		add	bx,hp_height
		dec	bx

		;-------ds:si now points to character data

		push	bx
		push	ax
		push	dx
		push	cx
		call    far  ptr  rect_fill
		add	sp,8

		pop	di
		pop	es
		pop     dx			;restore character position
		pop	cx
		;-----------------------------------------
	hp_next_char_cl:

	cmp	hp_orient,0
	$IF	E
		add	cx,hp_char_del
	$ELSE
		add	dx,hp_char_del
	$ENDIF

	jmp	hp_char_code_cl			;one more char
	clear_hp_string_exit:
	sti
	end_c_proc	_clear_hp_string, 8







        start_c_proc    get_hp_string_rect
                lds     si,dword ptr [bp+10]
                les     di,dword ptr [bp+10]

                inc     si

                cld

                xor     cx,cx
                mov     cl,byte ptr es:[di]
                mov     hp_str_len,cl
                rep     movsb

                xor     ax,ax
                mov     byte ptr es:[di],al

                push    [bp+8]
                push    [bp+6]
                push    [bp+10]
                push    [bp+12]
                push    [bp+16]
                push    [bp+14]

                call    far ptr _get_hp_string_rect

                lds     si,dword ptr [bp+10]
                les     di,dword ptr [bp+10]

                xor     ax,ax
                mov     al,hp_str_len
                add     si,ax
                add     di,ax
                dec     si

                std

                xor     cx,cx
                mov     cl,hp_str_len

                rep     movsb

                mov     al,hp_str_len
                mov     byte ptr es:[di],al

        end_c_proc      get_hp_string_rect,12







;***************************************************************************
;	This procedure is used to define the dimensions of hpstring box
;	ax contains width,dx contains height

	start_c_proc	_get_hp_string_rect

	push	[bp+14]
	pop	rect_addr
	push	[bp+16]
	pop	rect_addr+2


	mov	ax,[bp+10]
	mov	bx,[bp+12]

	les	di,dword ptr [bp+6]		;loads string pointer
	mov	ds,hp_data_seg

	cmp	byte ptr es:[di],0		;is string empty ?
	$IF	E
		mov	hpx,ax
		mov	hpy,bx
		add	ax,hp_cell_wid
		dec	ax
		mov	hpx1,ax
		add	bx,hp_cell_hi
		dec	bx
		mov	hpy1,bx
	$ELSE
		mov	hpx,07fffh
		mov	hpy,07fffh
		mov	hpx1,08001h
		mov	hpy1,08001h
		mov	cx,[bp+10]
		mov	dx,[bp+12]
	$ENDIF


	hp_char_code_sz:			;get character code
	mov	bl,es:[di]
	inc	di
	or	bl,bl				;is this terminate char
	je	hp_string_sz_exit_near		;exit procedure
	cmp	bl,0ah				;is this terminate char
	je	hp_string_sz_exit_near		;exit procedure


		xor	bh,bh			;get pointer to descriptor
		shl	bx,1
		mov	si,hp_charptrs[bx]	;es:di points to descriptor
		or	si,si			;skip if char not defined
		$IF	E
			push	hp_cell_wid
			pop	hp_char_del
			jmp	hp_next_char_sz
hp_string_sz_exit_near:
			jmp	hp_string_sz_exit
		$ENDIF

		push	cx
		push	dx

		;------- ds:si points to descriptor
		;------- store descriptors values
		add	si,6			;advance to info

		lodsw   			;hp left offset
		xchg	al,ah
		add	cx,ax			;update x

		lodsw				;hp top offset
		xchg	al,ah
		sub	dx,ax			;update y

		lodsw				;hp char width
		xchg	ah,al
		mov	hp_width,ax

		lodsw           		;hp char height
		xchg	ah,al
		mov	hp_height,ax

		lodsw
		xchg	ah,al			;hp char delta x
		shr	ax,1
		shr	ax,1
		mov	hp_char_del,ax

		mov	ax,cx			;get right x
		add	ax,hp_width
		dec	ax
		mov	bx,dx			;get bottom y
		add	bx,hp_height
		dec	bx

		;-----------------------------------------
		cmp     cx,hpx			;update string rectangle
		$IF	L
			mov	hpx,cx
		$ENDIF
		cmp	dx,hpy
		$IF	L
			mov	hpy,dx
		$ENDIF
		cmp     ax,hpx1
		$IF	G
			mov	hpx1,ax
		$ENDIF
		cmp	bx,hpy1
		$IF	G
			mov	hpy1,bx
		$ENDIF

	pop	dx
	pop	cx

	hp_next_char_sz:
	cmp	hp_orient,0
	$IF	E
		add	cx,hp_char_del
	$ELSE
		add	dx,hp_char_del
	$ENDIF
	jmp	hp_char_code_sz			;one more char

	hp_string_sz_exit:
		les	di,dword ptr rect_addr

		push	hpx
		pop	es:[di]
		push	hpy
		pop	es:[di+2]
		push	hpx1
		pop	es:[di+4]
		push	hpy1
		pop	es:[di+6]

	end_c_proc	_get_hp_string_rect,12
;****************************************************************
;	hp_asc2bin  converts asc decimal to bin
;	es:[di] points to lowest order digit, ax  has result

	hp_asc2bin	proc	near
	push	cx				;save registers
	push	bx
	push	di

	mov	ax,1
	xor	bx,bx
	xor	cx,cx				;accum in CX
	$DO
		mov	bl,es:[di]
		sub	bl,'0'
		$LEAVE	B			;exit if not digit
		cmp	bl,9
		$LEAVE	A
		push	ax			;save
		mul	bx
		add	cx,ax
		pop	ax
		mov	bx,10		; next order
		mul	bx
		dec	di
	$ENDDO
	mov	ax,cx

	pop	di
	pop	bx
	pop	cx
	ret
	hp_asc2bin	endp
; ***************************************************************************
;	This routine is used to define where the character set is in memory
;	and  to  set  up  hp font descriptor table
;	6	buffer_ptr  where font data are stored.

	start_c_proc	define_hp_font
	cld
	push	[bp+6]
	pop	hp_data_offs			; get offset

	push	[bp+8]
	pop	hp_data_seg			; get segment

	;------ Clear pointer table  to store font data
	mov	ax,CODE				;es:di points to descriptor ptr
	mov	es,ax				;table
	mov	di,offset hp_charptrs
		xor	ax,ax			;clear pointer table
		mov	cx,0FFH
		rep	stosw
	;------ get descriptor information
	les	di,dword ptr hp_data_offs
		mov	al,'W'
		mov	cx,20H			; search 32 bytes
		repne	scasb			; find W+1
	;------ save hp font parameters
	mov	ax,es:[di+6]			; base line
	xchg	ah,al
	mov	hp_base_line,ax
	mov	ax,es:[di+8]			; cell width
	xchg	ah,al
	mov	hp_cell_wid,ax
	mov	ax,es:[di+10]			; cell height
	xchg	ah,al
	mov	hp_cell_hi,ax
	mov	ax,es:[di+12]			; orientation / fixpro
	mov	hp_orient,al
	mov	hp_fixpro,ah
	;------ Find first char
	les	di,dword ptr hp_data_offs
	mov	al,'W'
	mov	cx,20H				; search 32 bytes
	repne	scasb				; finds W+1
	sub	di,2				; first digit
	call	hp_asc2bin
	add	di,2
	add	di,ax				; DI is past font descr.
	;------ build character pointer table
		$DO
		;------ find character ID code
		mov	al,'E'
		mov	cx,20H			; search 32 bytes
		repne	scasb			; finds E+1
		$LEAVE	NZ
		$LEAVE  CXZ
		sub	di,2
		call	hp_asc2bin		; AX char code
		mov	si,ax
		shl	si,1			; SI table entry
		cmp	hp_charptrs[si],0	; Exit on
		$LEAVE	NZ			; duplicate entry

		add	di,2			; point past

		mov	al,'W'
		mov	cx,20H			; search 32 bytes
		repne	scasb			; finds W+1
		mov	hp_charptrs[si],di	; descriptor offset
		sub	di,2
		call	hp_asc2bin		; get length
		add	di,2
		add	di,ax			; point past char data
		$ENDDO				; and repeat process

	define_font_exit:
	end_c_proc	define_hp_font,4



CODE	ends
;*****************************************************************************
	extrn	put_icon  : far
	extrn	rect_fill : far

	public	hp_string_out
	public	define_hp_font
	public	clear_hp_string
	public	get_hp_string_rect
END
